#!/bin/bash
. /etc/kona/soundsystem.inc

trace "autoupdatecheck in"

/etc/kona/startserver.sh

if [ ! -f /etc/kona/mpdstart ]; then
  if [ -f /var/run/mpd/pid ]; then
    kill $(cat /var/run/mpd/pid)
  fi
else
  ss="$(cat /etc/kona/soundsystem)"
  if [ "$ss" = "pipewire" ]; then
    ss="pulse"
  fi
  if [ ! -f /etc/kona/mpdalsa ] && [ -z "$(grep -v '#' ~/.config/mpd/mpd.conf | grep type | grep $ss)" ]; then
    trace "mpd config is incorrect - $ss"
    rm ~/.config/mpd/mpd.conf
    cp /etc/skel/.config/mpd/mpd_$ss.conf ~/.config/mpd
    ln -s ~/.config/mpd/mpd_$ss.conf ~/.config/mpd/mpd.conf
    trace mpd_$ss.conf
    systemctl --user stop mpd mpd.socket
  fi 
  if [ -z "$(pgrep mpd)" ]; then
    trace "mpd is started"
    systemctl --user start mpd
    if [ -f /etc/kona/hqmpd ]; then
      sleep 1
    fi
  fi
  if [ -f /etc/kona/hqmpd ]; then
    systemctl --user restart mpd
    trace "restart MPD"
  fi
fi
if [ -f /etc/kona/spotify ] && [ "$(pgrep librespot|wc -l)" -lt 2 ]; then
  if [ ! -f /etc/kona/hqspotify ]; then
    librespot -n "kona7-spotify($HOSTNAME)" &
  else
    cp /usr/bin/librespot $tmp
    $tmp/librespot -n "kona7-spotify($HOSTNAME)" &
  fi
  trace "$tmp spotify-start"
fi
#if [ ! -z "$(pgrep -f squeezebox)" ]; then
#  if [ -z "$(pgrep squeezelite)" ]; then
#    squeezelite &
#  fi
#fi
if [ -f /etc/kona/windsz ]; then
  windsz="$(cat /etc/kona/windsz)"
fi
if [ ! -z $windsz ] && [ ! -z "$(ip route)" ]; then
  notify-send "オーディオの準備ができるまで少々おまちください..." -i sound
  while [ -z "$(ip route|grep "initcwnd $windsz")" ]; do
    sleep 10
  done
fi
if [ "$(cat /etc/kona/soundsystem)" = "jack" ]; then
  while [ -z "$(pgrep jackd)" ]; do
    sleep 2
  done
fi
touch /etc/kona/audioready

if [ ! -f /etc/kona/soundrivers/$(uname -r)/snd-usb-audio.ko-avx.tgz ]; then
  rm -f snd-usb-audio.ko_$(uname -r).tgz
  wget -q --timeout=30 http://simosnet.com/debian/packages/Konalinux/debian/update/7.0/soundrivers/snd-usb-audio.ko_$(uname -r).tgz
  if [ -f snd-usb-audio.ko_$(uname -r).tgz ]; then
    mkdir -p /etc/kona/soundrivers/$(uname -r)
    tar xfz snd-usb-audio.ko_$(uname -r).tgz -C /etc/kona/soundrivers/$(uname -r)
  fi
  rm -f snd-usb-audio.ko_$(uname -r).tgz*
fi

if [ ! -f /etc/kona/soundrivers/$(uname -r)/xhci-hcd.ko-avx.tgz ]; then
  rm -f xhci-hcd.ko_$(uname -r).tgz
  wget -q --timeout=30 http://simosnet.com/debian/packages/Konalinux/debian/update/7.0/soundrivers/xhci-hcd.ko_$(uname -r).tgz
  if [ -f xhci-hcd.ko_$(uname -r).tgz ]; then
    mkdir -p /etc/kona/soundrivers/$(uname -r)
    tar xfz xhci-hcd.ko_$(uname -r).tgz -C /etc/kona/soundrivers/$(uname -r)
  fi
  rm -f xhci-hcd.ko_$(uname -r).tgz*
fi

if [ ! -f /etc/kona/soundrivers/$(uname -r)/snd-pcm.ko-avx.tgz ]; then
  rm -f snd-pcm.ko_$(uname -r).tgz
  wget -q --timeout=30 http://simosnet.com/debian/packages/Konalinux/debian/update/7.0/soundrivers/snd-pcm.ko_$(uname -r).tgz
  if [ -f snd-pcm.ko_$(uname -r).tgz ]; then
    mkdir -p /etc/kona/soundrivers/$(uname -r)
    tar xfz snd-pcm.ko_$(uname -r).tgz -C /etc/kona/soundrivers/$(uname -r)
    if [ -f /etc/kona/fastmemcpy ] || [ -f /etc/kona/fastmemcpy2 ]; then
      notify-send "高音質サウンドドライバーの準備ができました" "再起動するとシステムに組み込みます" -i "audio-speakers"
    fi
  fi
  rm -f snd-pcm.ko_$(uname -r).tgz*
fi
if [ ! -f /etc/kona/soundrivers/$(uname -r)/snd.ko-avx.tgz ]; then
  rm -f snd.ko_$(uname -r).tgz
  wget -q --timeout=30 http://simosnet.com/debian/packages/Konalinux/debian/update/7.0/soundrivers/snd.ko_$(uname -r).tgz
  if [ -f snd.ko_$(uname -r).tgz ]; then
    mkdir -p /etc/kona/soundrivers/$(uname -r)
    tar xfz snd.ko_$(uname -r).tgz -C /etc/kona/soundrivers/$(uname -r)
  fi
  rm -f snd.ko_$(uname -r).tgz*
fi

if [ ! -f /etc/kona/headless ]; then

soundsystem="$(cat /etc/kona/soundsystem)"
accel="$(cat /etc/kona/accelator)"
if [ "$(cat /etc/kona/janru)" != "none" ]; then
  janru=$(cat /etc/kona/janru)
fi
reso="$(cat /etc/kona/timeslice)"
slice=$((100 / $reso))
if [ -f /etc/kona/mpdstart ]; then
  mpd="MPD:起動中\n　"
else
  mpd=""
fi
mode=$(cat /etc/kona/soundmode)
if [ -f /etc/kona/fastmemcpy ] || [ -f /etc/kona/fastmemcpy2 ] || [ -f /etc/kona/autohqsd ]; then
  if [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org ]; then
    hqsoundriver="高音質サウンドドライバー：有効"
  fi
  if [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd.ko.org ]; then
    hqsoundriver="高音質サウンドドライバー(レベル-2）：有効"
  fi
fi
if [ -f /etc/kona/hqusbaudio ]; then
  if [ -f /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko.org ]; then
    if [ ! -z "$hqsoundriver" ]; then
      hqusbdriver="\n　USB Audio高音質ドライバー：有効"
    else
      hqusbdriver="USB Audio高音質ドライバー：有効"
    fi
  fi
fi
if [ -f /etc/kona/hsusb ]; then
  if [ -f /lib/modules/$(uname -r)/kernel/drivers/usb/host/xhci-hcd.ko.org ]; then
    if [ ! -z "$hqusbdriver" ] || [ ! -z "$hqsoundriver" ]; then
      hsusbdriver="\n　USB 高速ドライバー：有効"
    else
      hsusbdriver="USB 高速ドライバー：有効"
    fi
  fi
fi
if [  -f /etc/kona/preset ]; then
  preset="プリセット：$(cat /etc/kona/preset)"
fi
#sleep 3
audioicon="audio-speakers"
if [ ! -z "$(grep -i gnome /etc/kona/os-release)" ]; then
  notify-send "オーディオシステムの準備ができました" "このメッセージが出てからオーディオを使い始めてください\n\n　サウンド・システム：$soundsystem\n　ジャンル：$janru\n　モード : $mode\n　$hqsoundriver\n" -i "$audioicon"
else
  notify-send "オーディオシステムの準備ができました" "このメッセージが出てからオーディオを使い始めてください\n\n　カーネル：$(uname -r)\n　サウンド・システム：$soundsystem\n　ジャンル：$janru\n　モード : $mode\n　$mpd$hqsoundriver $hqusbdriver $hsusbdriver\n　$preset" -i "$audioicon"
fi
if [ -f /etc/kona/fastsoundriver ]; then
  rm -f /etc/kona/fastsoundriver
#  if [ -f /etc/kona/fastdriverdoing ]; then
#    rm /etc/kona/fastdriverdoing
#    zenity --warning --title="高音質サウンドドライバー" --text="高音質サウンドドライバーを組み込みました\n現在正常に動作しています" --no-wrap
#  else
    zenity --warning --title="高音質サウンドドライバー" --text="高音質サウンドドライバーを組み込みました\n再起動すると有効になります\n\n高音質サウンドドライバーを使うには\nセキュアブートをオフにしてください" --no-wrap
#  fi
fi
if [ -f /etc/kona/hqusbaudiodriver ]; then
  rm -f /etc/kona/hqusbaudiodriver
#  if [ -f /etc/kona/hqusbaudiodoing ]; then
#    rm /etc/kona/hqusbaudiodoing
#    zenity --warning --title="USB Audio高音質ドライバー" --text="USB Audio音質ドライバーを組み込みました\n現在正常に動作しています" --no-wrap
#  else
    zenity --warning --title="USB Audio高音質ドライバー" --text="USB Audio高音質ドライバーを組み込みました\n再起動すると有効になります\n\n高音質サウンドドライバーを使うには\nセキュアブートをオフにしてください" --no-wrap
#  fi
fi
if [ -f /etc/kona/hsusbdriver ]; then
  rm -f /etc/kona/hsusbdriver
  zenity --warning --title="USB高速ドライバー" --text="USB高速ドライバーを組み込みました\n再起動すると有効になります\n\n高速サウンドドライバーを使うには\nセキュアブートをオフにしてください" --no-wrap
fi

if [ ! -f /etc/kona/grubadderror ] && [ ! -d /run/live ]; then
  if [ -d /sys/firmware/efi ] && [ ! -d /boot/efi/EFI/Debian ]; then
    zenity --question --title="GRUB登録失敗" --text="DebianのEFIレコードがありません\nインストール時にGRUB関連のエラーが出ませんでしたか？\nGRUBの登録をスキップしたのでないならインストールしなおしてください\nEFIパーティションのマウントポイントは/boot/efiです\nなおDebian以外のブートレコードを使っているときは問題ありません\n\n今後このメッセージは表示しない" --no-wrap 
    if [ $? = "0" ]; then
      touch /etc/kona/grubadderror
    fi
  fi
fi

if [ ! -f /etc/kona/presetonce ] && [ ! -d /run/live ]; then
  touch /etc/kona/presetonce
  if [ "$(cat /etc/kona/preset)" = "デフォルト" ]; then
    zenity --info --title="ユーザープリセットの設定" --text="Kona Linux はサウンドの設定が非常に複雑なので\nユーザーに適した設定セットを最初に割り当てます" --no-wrap
    /etc/kona/presetset.sh 
  fi
fi

fi

touch /etc/kona/updatecheck
crontab -l > /etc/kona/updatecheck2.conf
if [ -z "$(grep updatecheck.sh /etc/kona/updatecheck2.conf)" ]; then
  cp /etc/kona/updatecheck.conf /etc/kona/updatecheck2.conf
fi
crontab /etc/kona/updatecheck2.conf

/etc/kona/desktopcheck.sh

if [ "$(cat /etc/kona/soundsystem)" = "pulse" ]; then
  if [ -z "$(pgrep pulseaudio)" ]; then
    systemctl --user start pulseaudio
    trace "pulseaudio force start"
  fi
fi

trace "autoupdatecheck out"
