#!/bin/bash
. /etc/kona/soundsystem.inc
sdsystem="pulse!pipewire!jack"
accelators="clear!normal!deep!clear-deep"
depths="normal!deep"
modes="normal!direct!hifi!deep!soft"
janrus="all!rock!jazz!classic!edm!hard rock!heavy metal!live"
cpuclockctl="performance!ondemand!powersave"
#outdevs="speaker!earphone/headphone"
hqdrivers="無効!レベル-1!レベル-2!自動"
hqdrivers2="無効!有効!自動"
refreshes="normal!high!low"
sqs="hifi!good"
rmems="4kb!8kb!16kb!32kb!64kb!128kb!256kb!512kb"
presets="デフォルト!高音質"
jacktools="qjackctl!cadence"
mpdouts="自動!alsa"
hqmpds="normal!high!max"
if [ ! -z "$(grep i386 /etc/kona/os-release)" ]; then
  sdsystem="pulse!jack"
fi
resolves="10!20!25!50!100!200"
#
system0="$(cat /etc/kona/soundsystem)"
resolve="$(cat /etc/kona/timeslice)"
outdev="$(cat /etc/kona/outdev)"
if [ -f /etc/kona/mpdstart ]; then
  mpdstart="TRUE"
else
  mpdstart="FALSE"
fi
listunits=$(systemctl list-unit-files|grep upmpdcli.service)
if [ ! -z "$listunits" ] && [ -z "$(echo $listunits|grep upmpdcli.service|grep disable)" ]; then
  upmpdcli0="TRUE"
else
  upmpdcli0="FALSE"
fi
#if [ -f /etc/kona/xrdpstart ] || [ -z "$(systemctl list-unit-files|grep xrdp.service|grep disable)" ]; then
#  xrdp0="TRUE"
#  touch /etc/kona/xrdpstart
#else
#  xrdp0="FALSE"
#fi
if [ -z "$(systemctl list-unit-files|grep bubbleupnpserver.service|grep disable)" ]; then
  bubbleupnp0="TRUE"
else
  bubbleupnp0="FALSE"
fi
#if [ -z "$(systemctl list-unit-files|grep logitechmediaserver.service|grep disable)" ]; then
#  squeeze0="TRUE"
#else
#  squeeze0="FALSE"
#fi
if [ -f /etc/kona/headless ]; then
  headless0="TRUE"
else
  headless0="FALSE"
fi
if [ -f /etc/kona/ramplayer ]; then
  ramplayer="TRUE"
else
  ramplayer="FALSE"
fi
if [ -f /etc/kona/ramserver ]; then
  ramserver="TRUE"
else
  ramserver="FALSE"
fi
fastmemcpy0="無効"
if [ -f /etc/kona/fastmemcpy ]; then
  fastmemcpy0="レベル-1"
fi
if [ -f /etc/kona/fastmemcpy2 ]; then
  fastmemcpy0="レベル-2"
fi
if [ -f /etc/kona/autohqsd ]; then
  fastmemcpy0="自動"
fi
if [ -f /etc/kona/baseboost ]; then
  baseboost="TRUE"
else
  baseboost="FALSE"
fi
if [ ! -f /etc/default/cpufrequtils ]; then
  cpufreqctl="ondemand"
else
  if [ ! -z "$(grep ondemand /etc/default/cpufrequtils)" ]; then
    cpufreqctl="ondemand"
  elif [ ! -z "$(grep performance /etc/default/cpufrequtils)" ]; then
    cpufreqctl="performance"
  else
    cpufreqctl="powersave"
  fi
fi
if [ -f /etc/kona/randomls ]; then
  randomls="TRUE"
else
  randomls="FALSE"
fi
#if [ -f /etc/kona/usbaudioreload ]; then
#  usbaudioreload="TRUE"
#else
#  usbaudioreload="FALSE"
#fi
if [ -f /etc/kona/restartserver ]; then
  restartserver="TRUE"
else
  restartserver="FALSE"
fi
if [ -f /etc/kona/hqusbaudio ]; then
  hqusbaudio="TRUE"
else
  hqusbaudio="FALSE"
fi
if [ -f /etc/kona/hsusb ]; then
  hsusb="TRUE"
else
  hsusb="FALSE"
fi
if [ ! -f /etc/kona/rmem ]; then
  rmem="128kb"
else
  rmem=$(cat /etc/kona/rmem)
  rmem=$(($rmem/1024))
  rmem="${rmem}kb"
fi
accelator="$(cat /etc/kona/accelator)"
if [ ! -f /etc/kona/soundmode ]; then
  mode="normal"
else
  mode="$(cat /etc/kona/soundmode)"
fi

refresh=$(cat /etc/kona/tmp)
if [ "$refresh" = "/var/lib/kona" ]; then
  refresh="normal"
elif [ "$refresh" = "/var/lib/kona/bin" ]; then
  refresh="low"
elif [ "$refresh" = "/dev/shm" ]; then
  refresh="high"
fi

if [ -f /etc/kona/depth ]; then
  depth="$(cat /etc/kona/depth)"
else
  depth="normal"
fi

jacktool="$(cat /etc/kona/jacktool)"
if [ -z "$jacktool" ]; then
  jacktool="qjackctl"
fi

if [ -f /etc/kona/hqalsa ]; then
  hqalsa="TRUE"
else
  hqalsa="FALSE"
fi

if [ -f /etc/kona/hqmpd ]; then
  hqmpd="$(cat /etc/kona/hqmpd)"
  if [ -z "$hqmpd" ]; then
    hqmpd="high"
  fi
else
  hqmpd="normal"
fi

if [ -f /etc/kona/spotify ]; then
  spotify0="TRUE"
else
  spotify0="FALSE"
fi

if [ ! -f /etc/kona/mpdalsa ]; then
  mpdout="自動"
else
  mpdout="alsa"
fi

if [ -f /etc/kona/preset ]; then
  preset0=$(cat /etc/kona/preset)
else
  preset0="カスタム"
fi
presets2="$(ls /etc/kona/presets)"
if [ ! -z "$presets2" ]; then
  presets="$presets!$(echo $presets2 | sed -e "s/ /!/g")"
fi
[ -f /etc/kona/janru ] || echo "all" > /etc/kona/janru
janru=$(cat /etc/kona/janru)
#[ -f /etc/kona/outdev ] || echo "speaker" > /etc/kona/outdev 
#outdev0=$(cat /etc/kona/outdev)

ret=$(yad --form --center --no-wrap --title="サウンドの設定" --image="/usr/share/icons/Adwaita/32x32/emblems/emblem-music-symbolic.symbolic.png" --text="サウンドを設定する\n" --field="プリセット(デフォルト):CB" --field="サウンド・システム(pulse):CB" --field="ジャンル(all):CB" --field="モード(normal):CB" --field="解像度(100):CB" --field="音の鮮度(normal):CB" --field="音の深さ(normal):CB" --field="プレイヤーをメモリーに置く:CHK" --field="ヘッドレスモード & Xrdpサーバーを起動する:CHK" --field="高音質サウンドドライバー(無効):CB" --field="USB Audio高音質ドライバーを有効にする:CHK" --field="USB高速ドライバーを有効にする:CHK" --field="CPUクロック制御(ondemand):CB" --field="TCP受信バッファサイズ(128kb):CB" --field="JACKツール(qjackctl):CB" --field="MPD出力先(自動):CB" --field="MPD音質:CB" --field="ALSAを高音質化する:CHK" --field="ランダムに起動音を鳴らす:CHK" --field="mpdを起動する:CHK"  --field="upmpdcliを起動する:CHK"  --field="bubbleupnpサーバーを起動する:CHK" --field="spotifyサーバーを起動する:CHK" --button="プリセットの設定(_P):2" --button="キャンセル(_C):1" --button="OK(_O):0" "$preset0!$presets" "$system0!$sdsystem" "$janru!$janrus" "$mode!$modes" "$resolve!$resolves" "$refresh!$refreshes" "$depth!$depths" "$ramplayer" "$headless0" "$fastmemcpy0!$hqdrivers" "$hqusbaudio" "$hsusb" "$cpufreqctl!$cpuclockctl" "$rmem!$rmems" "$jacktool!$jacktools" "$mpdout!$mpdouts" "$hqmpd!$hqmpds" "$hqalsa" "$randomls" "$mpdstart" "$upmpdcli0" "$bubbleupnp0" "$spotify0")
rcd="$?"
if [ "$rcd" = "0" ]; then
  preset="$(echo $ret|cut -d'|' -f1)"
  if [ "$preset" = "$preset0" ] && [ ! -f /etc/kona/preset2 ]; then
    preset="カスタム"
  fi
  if [ "$preset" != "カスタム" ]; then
    soundsystem="pulse"
    janru="all"
    mode="normal"
    resolve="100"
    refresh="normal"
    depth="normal"
    ramplayer="FALSE"
    cpufreqctl="ondemand"
    headless="FALSE"
    hqusbaudio="FALSE"
    hsusb="FALSE"
    fastmemcpy="無効"
    rmem="128kb"
    jacktool="qjackctl"
    hqalsa="FALSE"
    hqmpd="normal"
    mpdout="自動"
    if [ "$preset" = "高音質" ]; then
      mode="normal"
      fastmemcpy="レベル-2"
    elif [ "$preset" != "デフォルト" ]; then
      if [ ! -f /etc/kona/presets/"$preset" ]; then
        zenity --error --title="プリセットエラー" --text="このプリセット'$preset'は存在しません" --no-wrap
        exit
      fi
      soundsystem="$(cat /etc/kona/presets/$preset|grep soundsystem=|cut -d'=' -f2)"
      janru="$(cat /etc/kona/presets/$preset|grep janru=|cut -d'=' -f2)"
      mode="$(cat /etc/kona/presets/$preset|grep mode=|cut -d'=' -f2)"
      resolve="$(cat /etc/kona/presets/$preset|grep resolve=|cut -d'=' -f2)"
      refresh="$(cat /etc/kona/presets/$preset|grep refresh=|cut -d'=' -f2)"
      depth="$(cat /etc/kona/presets/$preset|grep depth=|cut -d'=' -f2)"
      [ -z "$depth" ] && depth="normal"
      ramplayer="$(cat /etc/kona/presets/$preset|grep ramplayer=|cut -d'=' -f2)"
      cpufreqctl="$(cat /etc/kona/presets/$preset|grep cpufreqctl=|cut -d'=' -f2)"
      headless="$(cat /etc/kona/presets/$preset|grep headless=|cut -d'=' -f2)"
      hqusbaudio="$(cat /etc/kona/presets/$preset|grep hqusbaudio=|cut -d'=' -f2)"
      hsusb="$(cat /etc/kona/presets/$preset|grep hsusb=|cut -d'=' -f2)"
      fastmemcpy="$(cat /etc/kona/presets/$preset|grep fastmemcpy=|cut -d'=' -f2)"
      rmem="$(cat /etc/kona/presets/$preset|grep rmem=|cut -d'=' -f2)"
      jacktool="$(cat /etc/kona/presets/$preset|grep jacktool=|cut -d'=' -f2)"
      hqalsa="$(cat /etc/kona/presets/$preset|grep hqalsa=|cut -d'=' -f2)"
      hqmpd="$(cat /etc/kona/presets/$preset|grep hqmpd=|cut -d'=' -f2)"
      mpdout="$(cat /etc/kona/presets/$preset|grep mpdout=|cut -d'=' -f2)"
    fi
    echo $preset > /etc/kona/preset
  else
    rm -f "/etc/kona/preset"
    soundsystem=$(echo $ret|cut -d'|' -f2)
    janru=$(echo $ret|cut -d'|' -f3)
    mode=$(echo $ret|cut -d'|' -f4)
#    if [ "$mode" = "hifi" ]; then
#      depth="normal"
#    else
#      depth="deep"
#    fi 
    resolve=$(echo $ret|cut -d'|' -f5)
    refresh=$(echo $ret|cut -d'|' -f6)
    depth=$(echo $ret|cut -d'|' -f7)
    [ -z "$depth" ] && depth="normal"
    ramplayer=$(echo $ret|cut -d'|' -f8)
    headless=$(echo $ret|cut -d'|' -f9)
    fastmemcpy=$(echo $ret|cut -d'|' -f10)
    hqusbaudio=$(echo $ret|cut -d'|' -f11)
    hsusb=$(echo $ret|cut -d'|' -f12)
    cpufreqctl=$(echo $ret|cut -d'|' -f13)
    rmem=$(echo $ret|cut -d'|' -f14)
    jacktool=$(echo $ret|cut -d'|' -f15)
    mpdout=$(echo $ret|cut -d'|' -f16)
    hqmpd=$(echo $ret|cut -d'|' -f17)
    hqalsa=$(echo $ret|cut -d'|' -f18)
  fi
  if [ "$soundsystem" != "$system0" ]; then
    if [ "$soundsystem" = "pulse" ] || [ "$soundsystem" = "jack" ]; then
      systemctl --user unmask pulseaudio 2> /dev/null
      systemctl --user mask pipewire 2> /dev/null
      systemctl --user mask pipewire-pulse 2> /dev/null
    else
      systemctl --user mask pulseaudio 2> /dev/null
      systemctl --user unmask pipewire 2> /dev/null
      systemctl --user unmask pipewire-pulse 2> /dev/null
    fi
  fi
  cd ~/.config/mpd
  rm -f mpd.conf
  if [ "$soundsystem" = "jack" ]; then
    ln -s mpd_jack.conf mpd.conf
    cp /etc/kona/qjackctl.desktop ~/.config/autostart
    if [ "$jacktool" = "qjackctl" ]; then
      cp /etc/kona/jacksink.desktop ~/.config/autostart
    else
      rm -f ~/.config/autostart/jacksink.desktop
      if [ -d /etc/kona/Cadence ] && [ ! -d ~/.config/Cadence ]; then
        cp -R /etc/kona/Cadence ~/.config
      fi
    fi
  else
    if [ "$mpdout" = "alsa" ]; then
      ln -s mpd_alsa.conf mpd.conf
    else
      ln -s mpd_pulse.conf mpd.conf
    fi
    rm -f ~/.config/autostart/qjackctl.desktop
    rm -f ~/.config/autostart/jacksink.desktop
  fi
  randomls=$(echo $ret|cut -d'|' -f19)
  mpd=$(echo $ret|cut -d'|' -f20)
  upmpdcli=$(echo $ret|cut -d'|' -f21)
  if [ "$upmpdcli" = "TRUE" ]; then
    mpd="TRUE"
  fi
  if [ "$mpd" = "FALSE" ]; then
    upmpdcli="FALSE"
  fi
  bubbleupnp=$(echo $ret|cut -d'|' -f22)
  spotify=$(echo $ret|cut -d'|' -f23)
#  squeeze=$(echo $ret|cut -d'|' -f23)
  echo "$soundsystem"  > /etc/kona/soundsystem
  baseboost="FALSE"
  case "$janru" in
	  "all") accelator="normal";;
	  "jazz") accelator="normal"
		 baseboost="TRUE";;
	  "classic") accelator="deep";;
	  "live") accelator="clear-deep";;
	  "edm" | "rock") accelator="clear"
		 baseboost="TRUE";;
	  "hard rock") accelator="clear-deep"
		 baseboost="TRUE";;
	  "metal" | "heavy metal") accelator="deep"
		 baseboost="TRUE";;
  esac  
  echo "$accelator"  > /etc/kona/accelator
  echo "$janru"  > /etc/kona/janru
  echo "$depth"  > /etc/kona/depth
  echo "$mode"  > /etc/kona/soundmode
  echo "$resolve"  > /etc/kona/timeslice
  if [ "$refresh" = "normal" ]; then
    echo /var/lib/kona > /etc/kona/tmp
  elif [ "$refresh" = "low" ]; then
    echo /var/lib/kona/bin > /etc/kona/tmp
  elif [ "$refresh" = "high" ]; then
    echo /dev/shm > /etc/kona/tmp
  fi
#  echo "$outdev" > /etc/kona/outdev
  if [ "$cpufreqctl" = "ondemand" ]; then
     cp /etc/kona/cpufrequtils_od /etc/default/cpufrequtils
  elif [ "$cpufreqctl" = "performance" ]; then
     cp /etc/kona/cpufrequtils_pm /etc/default/cpufrequtils
  else
     cp /etc/kona/cpufrequtils_ps /etc/default/cpufrequtils
  fi
  if [ "$rmem" = "128kb" ]; then
    rm -f /etc/kona/rmem
  else
    rmem="$(echo $rmem|cut -d'k' -f1)"
    rmem=$((${rmem} * 1024))
    echo $rmem > /etc/kona/rmem
  fi
  if [ ! -z "$jacktool" ]; then
    echo "$jacktool" > /etc/kona/jacktool
  else
    echo "qjackctl" > /etc/kona/jacktool
  fi
  if [ "$hqalsa" = "TRUE" ]; then
    touch /etc/kona/hqalsa
  else
    rm -f /etc/kona/hqalsa
  fi
  if [ "$hqmpd" != "normal" ]; then
    echo $hqmpd > /etc/kona/hqmpd
  else
    rm -f /etc/kona/hqmpd
  fi
  if [ "$mpdout" = "自動" ] || [ -z "$mpdout" ]; then
    rm -f /etc/kona/mpdalsa
  else
    touch /etc/kona/mpdalsa
  fi
  if [ "$mpd" = "TRUE" ]; then
    touch /etc/kona/mpdstart
    systemctl --user enable mpd mpd.socket 2> /dev/null
  else
    rm -f /etc/kona/mpdstart
    systemctl --user disable mpd mpd.socket 2> /dev/null
  fi
  if [ "$upmpdcli" != "$upmpdcli0" ]; then
  if [ "$upmpdcli" = "TRUE" ]; then
    gksudo systemctl enable upmpdcli.service 2> /dev/null
  else
    gksudo systemctl disable upmpdcli.service 2> /dev/null
  fi
  fi
  if [ "$bubbleupnp" != "$bubbleupnp0" ]; then
    if [ "$bubbleupnp" = "TRUE" ]; then
      gksudo systemctl enable bubbleupnpserver.service 2> /dev/null
    else
      gksudo systemctl disable bubbleupnpserver.service 2> /dev/null
    fi
  fi
#  if [ "$squeeze" != "$squeeze0" ]; then
#    if [ "$squeeze" = "TRUE" ]; then
#      gksudo systemctl enable logitechmediaserver.service 2> /dev/null
#    else
#      gksudo systemctl disable logitechmediaserver.service 2> /dev/null
#    fi
#  fi
#  if [ "$xrdp" != "$xrdp0" ]; then
#    if [ "$xrdp" = "TRUE" ]; then
#      zenity --warning --title="Xrdpサーバーの起動" --text="Xrdpサーバーの起動はヘッドレスモードと統合されました。\nXrdpサーバーを使うときはヘッドレスモードを有効にしてください" --no-wrap
#    else
#      pkexec chown $USER:$USER ~/.Xauthority
#      gksudo systemctl disable xrdp xrdp-sesman 2> /dev/null
##      mv /usr/lib/pulse-16.1+dfsg1/modules/module-xrdp-sink.so /etc/kona
##      mv /usr/lib/pulse-16.1+dfsg1/modules/module-xrdp-source.so /etc/kona
#      rm -f /etc/kona/xrdpstart
#    fi
#  else
#    if [  "$xrdp" = "TRUE" ]; then
#      zenity --warning --title="Xrdpサーバーの起動" --text="Xrdpサーバーの起動はヘッドレスモードと統合されました。\nXrdpサーバーを使うときはヘッドレスモードを有効にしてください" --no-wrap
#    fi
#  fi
  if [ "$fastmemcpy" = "自動" ]; then
    touch /etc/kona/autohqsd
    rm -f /etc/kona/fastmemcpy
    rm -f /etc/kona/fastmemcpy2
  else
    rm -f /etc/kona/autohqsd
    if [ "$fastmemcpy" != "無効" ]; then
      touch /etc/kona/fastmemcpy
      if [ "$fastmemcpy" = "レベル-2" ]; then
        touch /etc/kona/fastmemcpy2
      else
        rm -f /etc/kona/fastmemcpy2
      fi
#      if [ "$fastmemcpy0" = "無効" ]; then
#        zenity --warning --title="サウンドの設定" --text="高音質サウンドドライバーを使用するときはセキュアブートをオフにしてください" --no-wrap
#      fi
    else
      rm -f /etc/kona/fastmemcpy
      rm -f /etc/kona/fastmemcpy2
    fi
  fi
  if [ "$hqusbaudio" = "TRUE" ]; then
    touch /etc/kona/hqusbaudio
  else
    rm -f /etc/kona/hqusbaudio
  fi
  if [ "$hsusb" = "TRUE" ]; then
    touch /etc/kona/hsusb
  else
    rm -f /etc/kona/hsusb
  fi
  if [ "$spotify" != "$spotify0" ]; then
  if [ "$spotify" = "TRUE" ]; then
    gksudo systemctl enable raspotify
    touch /etc/kona/spotify
  else
    gksudo systemctl disable raspotify
    rm -f /etc/kona/spotify
  fi
  fi
  if [ "$baseboost" = "TRUE" ]; then
    touch /etc/kona/baseboost
  else
    rm -f /etc/kona/baseboost
  fi
  if [ "$headless" != "$headless0" ]; then
    if [ "$headless" = "TRUE" ]; then
      if [ -f /etc/kona/xrdpstart ]; then
        pkexec chown $USER:$USER ~/.Xauthority
        gksudo systemctl disable xrdp xrdp-sesman 2> /dev/null
        rm -f /etc/kona/xrdpstart
      fi
      gksudo systemctl set-default multi-user.target 2> /dev/null
      gksudo /etc/kona/autologinset.sh $USER
      systemctl --user enable mpd mpd.socket
      touch /etc/kona/headless
      zenity --info --title="サウンドの設定" --text="ヘッドレスモードに設定しました。\nデスクトップを表示するにはコマンド'desktop'を使用してください。" --no-wrap
      if [ -z "$(grep autoupdatecheck.sh ~/.bashrc)" ]; then
        echo /etc/kona/autoupdatecheck.sh >> ~/.bashrc
      fi
    else
      gksudo systemctl set-default graphical.target 2> /dev/null
      gksudo /etc/kona/autologinreset.sh
      if [ ! -f /etc/kona/mpdstart ]; then
        systemctl --user disable mpd mpd.socket
      fi
      sed -i -e "/autoupdatecheck.sh/d" ~/.bashrc
      rm -f /etc/kona/headless
    fi
  fi
  if [ "$ramplayer" = "TRUE" ]; then
    touch /etc/kona/ramplayer
  else
    rm -f /etc/kona/ramplayer
  fi
  if [ "$randomls" = "TRUE" ]; then
    touch /etc/kona/randomls
  else
    rm -f /etc/kona/randomls
  fi
  #if [ "$usbaudioreload" = "TRUE" ]; then
  #  touch /etc/kona/usbaudioreload
  #else
  #  rm -f /etc/kona/usbaudioreload
  #fi
  if [ "$restartserver" = "TRUE" ]; then
    touch /etc/kona/restartserver
  else
    rm -f /etc/kona/restartserver
  fi
#  if [ "$sq" = "hifi" ]; then
#    echo 20000 > /etc/kona/initram
#  else
#    rm -f /etc/kona/initram
#  fi
#  if [ "$ramserver" = "TRUE" ]; then
#    touch /etc/kona/ramserver
#  else
#    rm -f /etc/kona/ramserver
#  fi
#  echo preset=$preset
  if [ -f /etc/kona/hqusbaudio ] && [ -z "$(lsmod|grep snd_usb_audio)" ]; then
    zenity --warning --title="サウンドの設定" --text="高音質USBドライバーを使う設定になっていますが\nUSBにオーディオ機器を繋いでいないときは無効です" --no-wrap
  fi
  if [ "$preset" = "カスタム" ]; then
    if [ "$(cat /etc/kona/soundmode)" = "hifi" ] && ( [ -f /etc/kona/fastmemcpy2 ] || [ -f /etc/kona/hqusbaudio ] || [ -f /etc/kona/hsusb ] );  then
      rm -f /etc/kona/ramplayer 
      rm -f /etc/kona/hqmpd
      rm -f /etc/kona/hqalsa
      echo /var/lib/kona > /etc/kona/tmp
    fi
    zenity --info --title="サウンドの設定" --text="サウンドを設定しました\nシステムを再起動すると有効になります。" --no-wrap
  else
    zenity --info --title="サウンドの設定" --text="サウンドを$presetに設定しました\nシステムを再起動すると有効になります。" --no-wrap
  fi
  if [ "$preset" = "カスタム" ]; then
    zenity --question --title="プリセット保存" --text="設定値をプリセットとして保存しますか？" --no-wrap
    if [ "$?" = "0" ]; then
      if [ "$preset0" != "カスタム" ] && [ "$preset0" != "高音質" ] && [ "$preset0" != "デフォルト" ]; then
	presetnm="$preset0"
      fi
      presetl="$(ls /etc/kona/presets)"
      presetlist="$(echo $presetl|sed -e "s/ /!/g")" 
      presetname=$(yad --form --center --no-werap --title="プリセット保存" --text="プリセット名を入力してください\n" --field="プリセット名:CBE" "$presetnm!$presetlist")
      rcd="$?"
      presetname="$(echo $presetname|cut -d'|' -f1)"
      if [ "$rcd" = "0" ] && [ ! -z "$presetname" ]; then
	if [ "$presetname" = "高音質" ] || [ "$presetname" = "デフォルト" ] || [ "$presetname" = "カスタム" ]; then
	  zenity --warning --title="プリセット保存" --text="このプリセット名は使用できません" --no-wrap
	  exit
	fi
        if [ -f /etc/kona/presets/"$presetname" ]; then
           zenity --question --title="プリセット保存" --text="プリセット$presetnameが存在しますが上書きしますか？" --no-wrap
	  if [ "$?" != "0" ]; then
             zenity --question --title="プリセット削除" --text="プリセット$presetnameを削除しますか？" --no-wrap
	    if [ "$?" = "0" ]; then
	      rm /etc/kona/presets/"$presetname"
	    fi
	    exit
	  fi 
	fi
        echo "preset=$presetname" > /etc/kona/presets/$presetname
        echo "soundsystem=$soundsystem" >> /etc/kona/presets/$presetname
        echo "janru=$janru" >> /etc/kona/presets/$presetname
        echo "mode=$mode" >> /etc/kona/presets/$presetname
        echo "resolve=$resolve" >> /etc/kona/presets/$presetname
        echo "refresh=$refresh" >> /etc/kona/presets/$presetname
        echo "ramplayer=$ramplayer" >> /etc/kona/presets/$presetname
        echo "headless=$headless" >> /etc/kona/presets/$presetname
        echo "fastmemcpy=$fastmemcpy" >> /etc/kona/presets/$presetname
        echo "hqusbaudio=$hqusbaudio" >> /etc/kona/presets/$presetname
        echo "hsusb=$hsusb" >> /etc/kona/presets/$presetname
        echo "cpufreqctl=$cpufreqctl" >> /etc/kona/presets/$presetname
	if [ -z "$(echo $rmem|grep kb)" ]; then
	  rmem=$((rmem / 1024))
	  rmem=${rmem}kb
	fi
        echo "rmem=$rmem" >> /etc/kona/presets/$presetname
	echo "jacktool=$jacktool" >> /etc/kona/presets/$presetname
	echo "mpdout=$mpdout" >> /etc/kona/presets/$presetname
	echo "hqalsa=$hqalsa" >> /etc/kona/presets/$presetname
	echo $presetname > /etc/kona/preset
	zenity --info --title="プリセット保存" --text="プリセット$presetnameを保存しました" --no-wrap
      fi
    fi
  fi
elif [ "$rcd" = "2" ]; then
  /etc/kona/presetset.sh
fi
