#!/bin/bash
if [ ! -z $(pgrep -f nattended-upgrade) ]; then
  killall unattended-upgrade
fi

if [ ! -z "$(grep x86_64 /etc/kona/os-release)" ]; then
  arch="x86_64"
else
  arch="i386"
fi

apt-get -y -f install

apt-get update

if [ -z "$(dpkg -l|grep "ii  konalinux-7.0")" ]; then
  apt-get -y install konalinux-7.0
fi

if [ -z "$(dpkg -l|grep "ii  gnome-packagekit ")" ]; then
  apt-get -y install gnome-packagekit
fi

if [ -z "$(dpkg -l|grep "ii  lxpolkit")" ]; then
  apt-get -y install lxpolkit
fi

if [ -z "$(dpkg -l|grep gnome-software-plugin-flatpak)" ]; then
  apt-get -y install gnome-software-plugin-flatpak gnome-software-plugin-snap
fi

if [ -z "$(grep -i kde /etc/kona/os-release)" ]; then
  if [ -z "$(dpkg -l|grep "ii  package-update-indicator")" ]; then
    apt-get -y install package-update-indicator
    if [ ! -z "$(grep -i gnome /etc/kona/os-release)" ]; then
      sed -i -e "/NotShowIn/d" /etc/xdg/autostart/org.guido-berhoerster.code.package-update-indicator.desktop
    fi
  fi
fi
if [ -z "$(dpkg -l|grep "ii  libnotify-bin")" ]; then
  apt-get -y install libnotify-bin
fi

if [ -z "$(dpkg -l|grep "ii  waybar")" ]; then
  apt-get -y install waybar
  mv /etc/xdg/waybar/config_waybar /etc/xdg/waybar/config
fi

if [ -z "$(dpkg -l|grep "ii  upmpdcli")" ]; then
  apt-get -y install upmpdcli
  systemctl disable upmpdcli 2> /dev/null
fi

if [ -z "$(dpkg -l|grep "ii  cadence")" ]; then
  wget https://launchpad.net/~kxstudio-debian/+archive/kxstudio/+files/kxstudio-repos_11.1.0_all.deb
  if [ -f kxstudio-repos_11.1.0_all.deb ]; then
    dpkg -i kxstudio-repos_11.1.0_all.deb
    apt-get update
    apt-get -y install cadence
    rm -f kxstudio-repos_11.1.0_all.deb
  fi
fi

if [ ! -d /etc/kona/alsalib ]; then
  wget http://simosnet.com/debian/packages/Konalinux/debian/update/7.0/libasound.tgz
  if [ -f libasound.tgz ]; then
    mkdir /etc/kona/alsalib
    tar xfz libasound.tgz -C /etc/kona/alsalib
    rm libasound.tgz
  fi
fi

if [ -z "$(dpkg -l|grep qjackctl|grep 0.9.9-1-kona)" ]; then
  apt-get -y install qjackctl
fi

if [ -z "$(dpkg -l|grep audacious-plugins|grep 4.2.1-kona)" ]; then
  apt-get -y install audacious-plugins
fi

if [ ! -x /usr/bin/aqualung ]; then
  wget http://simosnet.com/debian/packages/Konalinux/debian/update/7.0/aqualung.tgz
  if [ -f aqualung.tgz ]; then
    tar xfz aqualung.tgz -C /
    rm aqualung.tgz
    apt-get -y install liblua5.4-0 liboggz2 liblrdf0
  fi
fi

if [ -z "$(dpkg -l|grep "ii  rapsotify")" ]; then
  apt-get -y install raspotify
  sed -i -e "s/#LIBRESPOT_BACKEND=\"alsa\"/LIBRESPOT_BACKEND=\"pulseaudio\"/" /etc/raspotify/conf
  systemctl disable raspotify
fi
if [ -z "$(dpkg -l|grep "ii  bubbleupnpserver")" ]; then
  apt-get -y install bubbleupnpserver
  mkdir -p /home/bubbleupnp
  chown bubbleupnp:bubbleupnp /home/bubbleupnp
  systemctl disable bubbleupnpserver
fi
if [ -z "$(dpkg -l|grep "ii  logitechmediaserver")" ]; then
  apt-get -y install logitechmediaserver squeezelite-pulseaudio
  usermod -aG audio squeezeboxserver
  addgroup lms
  usermod -aG lms squeezeboxserver
  systemctl disable logitechmediaserver
fi

apt-get clean
