#!/bin/bash
. /etc/kona/soundsystem.inc

if [ -f initsystem.sh ] && [ ! -z "$(diff initsystem.sh /etc/kona/initsystem.sh)" ]; then
  cp initsystem.sh /etc/kona/initsystem-new.sh
fi

if [ ! -z "$(diff initdesktop.sh /etc/kona/initdesktop.sh)" ]; then
  if [ ! -f /etc/kona/initdesktop ]; then
    cp initdesktop.sh /etc/kona
    rm -f /etc/kona/initdesktop-new.sh
  else
    cp initdesktop.sh /etc/kona/initdesktop-new.sh
  fi
  chmod 777 /etc/kona/initdesktop.sh
fi

if [ ! -z "$(diff initdesktop2.sh /etc/kona/initdesktop2.sh)" ]; then
  if [ ! -f /etc/kona/initdesktop2 ]; then
    cp initdesktop2.sh /etc/kona
    rm -f /etc/kona/initdesktop2-new.sh
  else
    cp initdesktop2.sh /etc/kona/initdesktop2-new.sh
  fi
  chmod 777 /etc/kona/initdesktop2.sh
fi

cp healthcheck.sh /etc/kona
cp wmcheck.sh checkwm.sh /etc/kona
cp pmcheck.sh /etc/kona
cp checksystem.sh /etc/kona
cp verifyupdate.sh /etc/kona
cp prelogout.sh /etc/kona
cp soundset.sh /etc/kona
cp autologinset.sh autologinreset.sh /etc/kona
cp pkexec /etc/kona
#cp GDebiGtk.py /usr/share/gdebi/GDebi
cp pulseset.sh /etc/kona
#for i in $(ls /home); do
#if [ -d /home/$i/.config ] && [ ! -d /home/$i/.config/pipewire ]; then
#  mkdir /home/$i/.config/pipewire
#  cp /etc/pipewire/pipewire.conf /home/$i/.config/pipewire
#  chown $i:$i /home/$i/.config/pipewire/pipewire.conf
#fi
#done
#for i in $(ls /home); do
#if [ -d /home/$i/.config ] && [ -d /home/$i/.config/pipewire ]; then
#  chown $i:$i /home/$i/.config/pipewire
#fi
#done
#if [ ! -d /etc/skel/.config/pipewire ]; then
#  mkdir /etc/skel/.config/pipewire
#  cp /etc/pipewire/pipewire.conf /etc/skel/.config/pipewire
#fi
cp setramserver.sh /etc/kona
cp checkserver.sh /etc/kona
cp autoupdatecheck.sh /etc/kona
cp loginsound.sh getloginsound.sh /etc/kona
pushd . > /dev/null
for i in $(ls /home)
do
  if [ -d /home/$i/.config/systemd/user ]; then
    cd /home/$i/.config/systemd/user
    if [ ! -L xdg-desktop-portal.service ]; then
      ln -s /dev/null xdg-desktop-portal.service
      chown $i:$i xdg-desktop-portal.service
    fi
  fi
done
popd > /dev/null
if [ ! -f /etc/kona/setonce6 ]; then
  touch /etc/kona/setonce6
  for i in $(ls /home); do
    sed -i -e "s/speex-float-4/speex-float-5/" /home/$i/.config/pulse/daemon.conf
  done
  rm -f /etc/kona/setonce5
fi
#if [ -f rmem ]; then
#  cp rmem /etc/kona
#else
#  rm -f /etc/kona/rmem
#fi
if [ -f /etc/kona/rmem ]; then
  chmod 777 /etc/kona/rmem
fi
if [ ! -f /etc/kona/vars ]; then
  cp vars /etc/kona/vars
fi
if [ -f /etc/kona/vars ]; then
  chmod 777 /etc/kona/vars
fi
if [ -z "$(dpkg -l|grep "ii  gnome-packagekit ")" ]; then
  cp update-desktop.sh /etc/kona/update
fi
rm -f /etc/apt/sources.list.d/skype-stable.list
if [ -f windsz ]; then
  cp windsz /etc/kona
else
  rm -f /etc/kona/windsz
fi
if [ ! -f /etc/kona/setonce1 ]; then
  crontab -r
  touch /etc/kona/setonce1
fi
cp systemcheck.conf systemcheck.sh /etc/kona
if [ "$(cat /etc/kona/version)" = "202305" ]; then
  rm -f /etc/kona/update/update-202305t.tgz
fi
cp prenetworking.sh /etc/kona
cp リリースノート.txt /etc/skel/Desktop
if [ ! -f /etc/kona/setonce3 ]; then
  cp lightdm-gtk-greeter.conf /etc/lightdm
  cp slick-greeter.conf /etc/lightdm
  touch /etc/kona/setonce3
fi
sed -i -e "s/#ControllerMode = dual/ControllerMode = bredr/" /etc/bluetooth/main.conf
if [ -f kona-grub.png ]; then
  cp kona-grub.png /usr/share/desktop-base/active-theme/grub
fi
if [ ! -f /etc/kona/setonce4 ]; then
  touch /etc/kona/setonce4
  cp pipewire.conf /usr/share/pipewire
fi
cp soundsystem.sh /etc/kona
cp bluetooth2.service /lib/systemd/system
cp soundsystem.inc /etc/kona
cp refreshsoundserver.sh /etc/kona
cp autostart /etc/sway/config.d
if [ ! -f /etc/kona/setonce2 ]; then
  touch /etc/kona/setonce2
  ln -s /etc/kona/soundset.sh /usr/local/bin/soundset
  ln -s /etc/kona/pulseset.sh /usr/local/bin/pulseset
fi
if [ -z "$(dpkg -l|grep "ii  lxpolkit")" ]; then
  cp update-desktop.sh /etc/kona/update
fi
if [ -z "$(grep 7.0/ /etc/kona/os-release)" ]; then
  if [ ! -z "$(grep 7.0/ /etc/kona/lsb-release)" ]; then
    ed="$(grep 7.0 /etc/kona/os-release|awk '{print $4}'|cut -d'/' -f1)"
    sed -i -e "s/7.0/7.0 $ed/" /etc/kona/lsb-release
  fi
fi
if [ ! -z "$(dpkg -l|grep "ii  rtkit")" ]; then
  dpkg --purge rtkit
fi
if [ ! -f /etc/kona/soundmode ]; then
  echo "normal" > /etc/kona/soundmode
fi
if [ -f /etc/kona/soundmode ]; then
  chmod 777 /etc/kona/soundmode
fi

if [ -z "$(dpkg -l|grep gnome-software-plugin-flatpak)" ]; then
  cp update-desktop.sh /etc/kona/update
fi

cp installxanmod.sh installxanmod2.sh installhqskernel.sh /etc/kona
#cp installxanmod.desktop /usr/share/applications
rm -f /usr/share/applications/installxanmod.desktop
cp installhqskernel.desktop /usr/share/applications

rm -f /etc/xdg/autostart/calamares-desktop-icon.desktop

#cp setpci.sh /etc/kona
#cp latency_timer latency_timer_audio /etc/kona

if [ -z "$(grep -i kde /etc/kona/os-release)" ]; then
  if [ -z "$(dpkg -l|grep package-update-indicator)" ]; then
    cp update-desktop.sh /etc/kona/update
  fi
fi
cp update-notifier.sh /etc/kona
if [ -z "$(dpkg -l|grep libnotify-bin)" ]; then
  cp update-desktop.sh /etc/kona/update
fi
if [ ! -z "$(grep -i gnome /etc/kona/os-release)" ]; then
  if [ -f /etc/xdg/autostart/org.guido-berhoerster.code.package-update-indicator.desktop ]; then
    if [ ! -z "$(grep NotShowIn /etc/xdg/autostart/org.guido-berhoerster.code.package-update-indicator.desktop)" ]; then
      sed -i -e "/NotShowIn/d" /etc/xdg/autostart/org.guido-berhoerster.code.package-update-indicator.desktop
    fi
  fi
fi

if [ ! -f /etc/kona/monthn ]; then
  date "+%m" > /etc/kona/monthn
fi
if [ -f /etc/kona/monthn ]; then
  chmod 777 /etc/kona/monthn
fi
#if [ !  -f /usr/share/backgrounds/kona/swaybackground.jpg ]; then
#  cp swaybackground.jpg /usr/share/backgrounds/kona
#  cp config /etc/sway
#fi


if [ -z "$(dpkg -l|grep waybar)" ]; then
  cp update-desktop.sh /etc/kona/update
fi
mkdir -p /etc/xdg/waybar
cp config_waybar /etc/xdg/waybar
cp autostart /etc/sway/config.d
cp config_sway /etc/sway/config

rm -fr /etc/skel/.config/wabar
for i in $(ls /home); do
  if [ -d /home/$i/.config/waybar ]; then
    rm -fr /home/$i/.config/waybar
  fi
done

if [ -z "$(grep kernel2 /etc/apt/sources.list.d/konalinux.list)" ]; then
  cp konalinux.list /etc/apt/sources.list.d
fi

cp cpufrequtils_* /etc/kona
if [ -f /etc/kona/performance ]; then
  rm /etc/kona/performance
  cp cpufrequtils_pm /etc/default/cpufrequtils
else
  cp cpufrequtils_od /etc/default/cpufrequtils
fi
chmod 777 /etc/default/cpufrequtils

if [ ! -f /etc/kona/hqsd.conf ]; then
  cp hqsd.conf /etc/kona
else
  if [ -z "$(grep 6.1.37-rt13 /etc/kona/hqsd.conf)" ]; then
    cp hqsd.conf /etc/kona
  fi
fi
if [ -f /etc/kona/hqsd.conf ]; then
  chmod 777 /etc/kona/hqsd.conf
fi

if [ ! -z "$(grep ^xenomai-kona /etc/kona/hqsd.conf)" ]; then
  sed -i -e "s/xenomai-kona/#xenomai-kona/" /etc/kona/hqsd.conf
fi

if [ ! -f /etc/kona/tmp ]; then
  echo "/var/lib/kona" > /etc/kona/tmp
fi
chmod 777 /etc/kona/tmp

cp libc.conf /etc/ld.so.conf.d
cp systemdiagnose.sh /etc/kona

if [ ! -f /etc/kona/setonce7 ]; then
  touch /etc/kona/setonce7
  rm -f /etc/kona/rmem
fi

mkdir -p /etc/kona/presets
chmod 777 /etc/kona/presets

if [ ! -f /etc/kona/setonce8 ]; then
  touch /etc/kona/setonce8
  if [ -f /etc/kona/soundrivers/6.1.0-11-amd64/snd-usb-audio.ko.tgz ]; then
    rm -f /etc/kona/soundrivers/$(uname -r)/snd-usb-audio.ko.tgz
    rm -f /etc/kona/soundrivers/$(uname -r)/snd-usb-audio.ko-avx.tgz
  fi
fi

if [ ! -f /etc/kona/depth ]; then
  echo normal > / etc/kona/depth
  chmod 777 /etc/kona/depth
fi

if [ -f /etc/kona/preset ]; then
if [ "$(cat /etc/kona/preset)" = "デフォルト" ]; then
  if [ "$(cat /etc/kona/depth)" != "normal" ]; then
    echo normal > /etc/kona/depth
    chmod 777 /etc/kona/depth
  fi
fi
fi

if [ -z "$(grep -i -e 7.0/ -e xfce /etc/kona/os-release)" ]; then
  if [ ! -z "$(dpkg -l|grep xfce4-notifyd)" ]; then
    dpkg --purge xfce4-notifyd
  fi
fi

if [ -z "$(dpkg -l|grep "ii  upmpdcli")" ]; then
  cp lesbonscomptes.gpg /usr/share/keyrings
  cp upmpdcli-bookworm.list /etc/apt/sources.list.d
  cp update-desktop.sh /etc/kona/update
fi

cp qjackctl.sh /etc/kona
cp jacksink.* /etc/kona

if [ "$(cat /etc/kona/soundsystem)" = "jack" ]; then
  for i in $(ls /home); do
    if [ -d /home/$i/.config/autostart ]; then
      if [ ! -f /home/$i/.config/autostart/qjackctl.desktop ]; then
	cp qjackctl.desktop /home/$i/.config/autostart
	chmod 777 /home/$i/.config/autostart/qjackctl.desktop
      fi
      if [ ! -f /home/$i/.config/autostart/jacksink.desktop ]; then
	cp jacksink.desktop /home/$i/.config/autostart
	chmod 777 /home/$i/.config/autostart/jacksink.desktop
      fi
    fi
  done
fi

cp jackstart /etc/kona
rm -f /etc/kona/jackdrc
cp startserver.sh /etc/kona
rm -f /etc/kona/jackdrc
if [ ! -f /etc/kona/setonce9 ]; then
  touch /etc/kona/setonce9
  for i in $(ls /home); do
    if [ -f /home/$i/.bashrc ]; then
      if [ ! -z "$(grep .jackdrc /home/$i/.bashrc)" ]; then
        cp _bashrc /home/$i/.bashrc
        chown $i:$i /home/$i/.bashrc
      fi
    fi
  done
fi
if [ -z "$(dpkg -l|grep "ii  cadence")" ]; then
  cp update-desktop.sh /etc/kona/update
fi

if [ ! -f /etc/kona/jacktool ]; then
  echo qjackctl > /etc/kona/jacktool
fi
chmod 777 /etc/kona/jacktool
if [ "$(cat /etc/kona/jacktool)" = "cadence" ]; then
  for i in $(ls /home); do
    if [ -d /home/$i/autostart ]; then
      rm -f /home/$i/autostart/jacksink.desktop
    fi
  done
fi 

if [ -d /etc/kona/soundrivers/6.1.37-rt13-rc1-kona ]; then
  if [ ! -f /etc/kona/soundrivers/6.1.37-rt13-rc1-kona/snd.ko.tgz ]; then
    rm -fr /etc/kona/soundrivers/6.1.37-rt13-rc1-kona
  fi
fi

if [ ! -d /etc/kona/alsalib ]; then
  cp update-desktop.sh /etc/kona/update
fi

cp 高音質USB /etc/kona/presets
cp 高速カーネル /etc/kona/presets
cp ダイレクト /etc/kona/presets
cp ダイレクトUSB /etc/kona/presets
cp ダイレクトハイブリッド /etc/kona/presets
cp 高音質ハイブリッド /etc/kona/presets

pushd . > /dev/null
cd /etc/kona/presets
rm -f 最高音質*
rm -f カスタム
rm -f ハイブリッド
rm -f xenomai-evl* クラシック Direct Xenomai4
rm -f ディープ 癒やし いやし
popd > /dev/null
if [ -f /etc/kona/preset ]; then
  if [ "$(cat /etc/kona/preset)" = "最高音質-notusb" ]; then
    echo 高音質 > /etc/kona/preset
  elif [ "$(cat /etc/kona/preset)" = "最高音質２(ソフト)" ]; then
    echo 高音質 > /etc/kona/preset
  elif [ "$(cat /etc/kona/preset)" = "最高音質３(クリア)" ]; then
    echo 高音質 > /etc/kona/preset
  elif [ "$(cat /etc/kona/preset)" = "xenomao-evl" ]; then
    echo 高音質 > /etc/kona/preset
  elif [ "$(cat /etc/kona/preset)" = "クラシック" ]; then
    echo デフォルト > /etc/kona/preset
  elif [ "$(cat /etc/kona/preset)" = "ハイブリッド" ]; then
    echo ダイレクトハイブリッド > /etc/kona/preset
  elif [ "$(cat /etc/kona/preset)" = "最高音質USB" ]; then
    echo 高音質USB > /etc/kona/preset
  elif [ "$(cat /etc/kona/preset)" = "Direct" ]; then
    echo ダイレクトハイブリッド > /etc/kona/preset
  elif [ "$(cat /etc/kona/preset)" = "Xenomai4" ]; then
    echo 高音質 > /etc/kona/preset
    echo normal > /etc/kona/soundmode
  fi
fi

if [ -d /usr/share/cadence/src ]; then
  cp shared_canvasjack.py /usr/share/cadence/src
  cp ui_settings_jack.py /usr/share/cadence/src
fi

if [ -z "$(dpkg -l|grep qjackctl|grep 0.9.9-1-kona)" ]; then
  cp update-desktop.sh /etc/kona/update
fi
if [ -z "$(dpkg -l|grep audacious-plugins|grep 4.2.1-kona)" ]; then
  cp update-desktop.sh /etc/kona/update
fi

if [ ! -x /usr/bin/aqualung ]; then
  cp update-desktop.sh /etc/kona/update
fi

cp cadence qjackctl /usr/local/bin
if [ ! -f /etc/kona/waitime ]; then
  echo 0.5 > /etc/kona/waitime
  chmod 777 /etc/kona/waitime
fi
if [ ! -f /etc/kona/setonce5 ]; then
  rm -f /etc/kona/setonce10
  touch /etc/kona/setonce5
  touch /etc/kona/touchpad
  chmod 777 /etc/kona/touchpad
fi
if [ ! -z "$(grep 7.0/ /etc/kona/os-release)" ]; then
  cp touchpadset.desktop /usr/share/applications
  cp touchpadset.sh /etc/kona
fi

if [ "$(cat /etc/kona/soundmode)" = "clear" ]; then
  echo normal > /etc/kona/soundmode
fi

if [ -d /etc/kona/soundrivers/6.5.0-xenomai4-kona ]; then
  if [ -f /etc/kona/soundrivers/6.5.0-xenomai4-kona/xhci-hcd.ko-avx.ko.tgz ]; then
    mv xhci-hcd.ko-avx.ko.tgz xhci-hcd.ko-avx.tgz
  fi
fi

if [ "$(cat /etc/kona/soundmode)" = "clear" ]; then
  echo normal > /etc/kona/soundmode
fi
if [ "$(cat /etc/kona/soundmode)" = "soft" ]; then
  echo deep > /etc/kona/soundmode
fi
cp presetset.sh /etc/kona
if [ ! -f /etc/kona/setonce10 ]; then
  touch /etc/kona/setonce10
  rm -f /etc/kona/soundrivers/6.1.0-13-amd64/snd-usb-audio.ko*
  rm -f /etc/kona/soundrivers/6.5.0-xenomai4-kona/snd-usb-audio.ko*
fi

if [ -f /etc/kona/preset ]; then
  if [ "$(cat /etc/kona/soundmode)" = "direct" ] || [ -z "$(grep ダイレクト /etc/kona/preset)" ]; then
    if [ ! -z "$(grep 高音質 /etc/kona/preset)" ] || [ "$(cat /etc/kona/preset)" = "デフォルト" ]; then
      echo normal > /etc/kona/soundmode
    fi
  fi
fi

if [ ! -f /etc/kona/setonce13 ]; then
  touch /etc/kona/setonce13
  rm -f /etc/kona/soundrivers/*/snd-usb-audio.ko*.tgz
fi

chmod 644 /etc/skel/.config/mpd/mpd_jack.conf

if [ -f /etc/kona/mpdstart ]; then
  if [ ! -f /etc/kona/setonce14 ]; then
    touch /etc/kona/setonce14
    rm -f /etc/kona/setonce11
    rm -f /etc/kona/setonce12
    if [ ! -z "$(systemctl list-unit-files|grep upmpdcli|grep disable)" ]; then
      systemctl enable upmpdcli 2> /dev/null
    fi
  fi
fi

if [ -z "$(dpkg -l|grep "ii  raspotify")" ]; then
  cp update-desktop.sh /etc/kona/update
fi
if [ -z "$(dpkg -l|grep "ii  bubbleupnpserver")" ]; then
  cp update-desktop.sh /etc/kona/update
fi
if [ -z "$(dpkg -l|grep "ii  logitechmediaserver")" ]; then
  cp update-desktop.sh /etc/kona/update
fi

cp updatecheck.sh /etc/kona

if [ -f /etc/kona/preset ] && [ "$(cat /etc/kona/preset)" = "デフォルト" ]; then
  echo deep > /etc/kona/soundmode
fi

cp desktopcheck.sh /etc/kona

if [ ! -z "$(grep SeatDefaults /etc/lightdm/lightdm.conf)" ]; then
  sed -i -e "s/SeatDefaults/Seat:\*/" /etc/lightdm/lightdm.conf
fi

systemctl enable upower 2> /dev/null

cp hqsd.conf /etc/kona

cp initdesktop.desktop /etc/xdg/autostart
cp initdesktop.desktop /etc/kona

if [ -f /etc/kona/hqmpd ]; them
  if [ -z "$(cat /etc/kona/hqmpd)" ]; then
    echo "high" > /etc/kona/hqmpd
    chmod 777 /etc/kona/hqmpd
  fi
fi

